/*******************************************************************************
* File Name: main.c
*
* Version: 1.0
*
* Description:
* This example project demonstrates the basic functionality of the DVDAC
* component. The Delta Sigma ADC component is used to measure the output
* voltage.
*
********************************************************************************
* Copyright 2013-2014, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include <project.h>
#include <stdio.h>
#include <DVDAC.h>

float ADC_DelSig_ReadInt32(void);


int main()
{
    uint16 i;
    char   line[16u];

    /* Start components */
    DVDAC_Start();
    ADC_DelSig_Start();
    LCD_Start();

    for(;;)
    {
        for(i=0u; i < DVDAC_DVDAC_MAX_VALUE; i++)
        {
            DVDAC_SetValue(i);

            sprintf(
            line, "Vdvdac=%4.2fmV",
            (float) ADC_DelSig_ReadInt32()
            );

            LCD_ClearDisplay();
            LCD_Position(0u, 0u);
            LCD_PrintString("DVDAC Example");
            LCD_Position(1u, 0u);
            LCD_PrintString(line);

            CyDelay(800u);
        }
    }
}


float ADC_DelSig_ReadInt32(void)
{
    float result;

    ADC_DelSig_DEC_SR_REG |= ADC_DelSig_DEC_INTR_CLEAR;
    ADC_DelSig_StartConvert();
    (void) ADC_DelSig_IsEndConversion(ADC_DelSig_WAIT_FOR_RESULT);
    ADC_DelSig_StopConvert();
    result = ADC_DelSig_CountsTo_Volts(ADC_DelSig_GetResult32()) * 1000.0;

    return(result);
}


/* [] END OF FILE */
